Subject: bug#10928: 24.0.94; dired-mode on /proj/foo/bar gives error : dir-locals-read-from-file: Opening input file: No such file or directory, /proj/.dir-locals.el

From: Glenn Morris <[email-masked]>
Date: Mon, 05 Mar 2012 21:51:52 -0500

Vardhan Varma wrote:

> $  ls -l /proj/.dir-locals.el
> ls: /proj/.dir-locals.el: No such file or directory
> $  ls -dl /proj/.dir-locals.el
> dr-xr-xr-x 2 root root 0 Jan  5 02:33 /proj/.dir-locals.el

Is there really a /proj/.dir-locals.el directory (not file)?
(How does it have zero size - what is the file system?)
Can you just delete whatever that is?

It looks to me like your automounter is broken, because the above
sequence ought to be impossible, AIUI.

> To me, it looks like the automount is playing some tricks .. initially
> it tells emacs that this exists 
> and when emacs tries to read it .. it tells that it doesn't exist ... or
> something like that ...
[...]
> stat("/proj/foo/.dir-locals.el", 0x7fff6e27f590) = -1 ENOENT (No such
> file or directory)
> stat("/proj/.dir-locals.el", {st_mode=S_IFDIR|0555, st_size=0, ...}) = 0
> stat("/proj/.dir-locals.el", {st_mode=S_IFDIR|0555, st_size=0, ...}) = 0
> open("/proj/.dir-locals.el", O_RDONLY)  = -1 ENOENT (No such file or
> directory)

I don't understand what's going on there, but I made Emacs ignore
.dir-locals.el if it is a directory (or unreadable). I guess that will
fix your issue. But if /proj/.dir-locals.el was a weird file rather than
a weird directory, the same issue would occur. I don't think there would
anything Emacs could do about that.